;##########################################################################
.386
.model flat, stdcall
option casemap:none
title LZ77 Unpacker
;##########################################################################
include C:\masm32\include\windows.inc
include C:\masm32\include\kernel32.inc
include C:\masm32\include\user32.inc
includelib C:\masm32\lib\kernel32.lib
includelib C:\masm32\lib\user32.lib
;##########################################################################
szText MACRO Name, Text:VARARG
LOCAL lbl
	jmp	lbl
	Name	db	Text, 0
lbl:
ENDM
m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
m2mx MACRO M1, M2
	mov	eax, M2
	mov	M1, eax
ENDM
return MACRO RETVALUE
	mov	eax, RETVALUE
	ret
ENDM
iif MACRO condition, if_true, if_false, return
	.if condition
		mov	return, if_true
	.else
		mov	return, if_false
	.endif
ENDM
iifs MACRO condition, if_true, if_false, return
	mov	return, if_false
	.if condition
		mov	return, if_true
	.endif
ENDM
;##########################################################################
;##########################################################################
	CurDate		TEXTEQU		<">, @Date, <">
	CurTime		TEXTEQU		<">, @Time, <">
	CurFileName	TEXTEQU		<">, @FileCur, <">
;##########################################################################
unpack		PROTO	:PTR BYTE,:DWORD,:PTR BYTE
ProcessCmdLine	PROTO
ErrorHandler	PROTO C	:DWORD,:DWORD,:DWORD,:DWORD
ExceptionFilter	PROTO	:DWORD
;##########################################################################
.const
	szMsgAbout	db		"LZ77 Unpacker", 13, 10
			db		"Built on ", CurDate, " ", CurTime, 13, 10
			db		"Version 1.0", 13, 10
			db		"Coded by comrade <comrade2k@hotmail.com>", 13, 10
			db		"Web: http://euro.comrade64.com/", 13, 10
			db		"     http://comrade64.cjb.net/", 13, 10
			db		"     http://comrade.ownz.com/", 13, 10
			db		"     http://comrade.win32asm.com/", 13, 10
			db		"     http://comrade.hpacv.dk/", 13, 10
			db		"     http://www.comrade64.com/", 13, 10
			db		"IRC: #asm, #coders, #win32asm on EFnet", 13, 10
	dwMsgAboutLen	equ		$ - szMsgAbout
	szMsgUsage	db		"Usage: unpack.exe input output", 13, 10
	szErrorThread	db		13, 10, "Error at %08Xh", 13, 10, "Registers:", 13, 10, "eax = %08Xh ebx = %08Xh ecx = %08Xh", 13, 10, "edx = %08Xh esp = %08Xh ebp = %08Xh", 13, 10, "esi = %08Xh edi = %08Xh", 13, 10, 13, 10, "Recovering...", 13, 10, 0
	szErrorFinal	db		13, 10, "Error at %08Xh", 13, 10, "Quitting...", 13, 10, 0
;##########################################################################
.data
;##########################################################################
.data?
	hFileIn		dd		?
	hFileMapIn	dd		?
	dwFileIn	dd		?
	dwPackedSize	dd		?
	hFileOut	dd		?
	hMemoryFileOut	dd		?
	dwFileOut	dd		?
	dwUnpackedSize	dd		?
	hStdOut		dd		?
	szMessage	db		256 dup (?)
	seh		dd		6 dup (?)

	data_start	equ		$
	argc		dd		?
	argv		dd		16 dup (?)
	data_size	equ		$ - data_start
;##########################################################################
.code
start:	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov	[hStdOut], eax
	invoke	SetUnhandledExceptionFilter, ADDR ExceptionFilter
	invoke	WriteFile, [hStdOut], ADDR szMsgAbout, dwMsgAboutLen, esp, 0
	; install the SEH-frame
	assume	fs:nothing
	push	OFFSET ErrorHandler
	push	FS:[0]
	mov	[seh], esp
	mov	[seh+4], ebp
	mov	[seh+8], ebx
	mov	[seh+12], esi
	mov	[seh+16], edi
	mov	[seh+20], OFFSET @@safe
	mov	FS:[0], esp
	; critical code
	; zero uninitialized data
	push	edi
	xor	eax, eax
	mov	ecx, data_size shr 2
	mov	edi, data_start
	rep	stosd
	IF data_size AND 3
		mov	edi, data_start
		mov	ecx, data_size and 3
		rep	stosb
	ENDIF
	push	esi
	push	ebx
	call	ProcessCmdLine
	.if [argc]!=3
		invoke	WriteFile, [hStdOut], ADDR szMsgUsage, sizeof szMsgUsage, esp, 0
		jmp	@@exit
	.endif
	invoke	CreateFile, [argv+04h], GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0
	mov	[hFileIn], eax
	invoke	CreateFileMapping, eax, 0, PAGE_READONLY, 0, 0, 0
	mov	[hFileMapIn], eax
	invoke	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
	mov	[dwFileIn], eax
	invoke	GetFileSize, [hFileIn], 0
	mov	[dwPackedSize], eax
	invoke	ReadFile, [hFileIn], ADDR dwUnpackedSize, sizeof dwUnpackedSize, esp, 0
	invoke	CreateFile, [argv+08h], GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0
	mov	[hFileOut], eax
	invoke	GlobalAlloc, GMEM_MOVEABLE, [dwUnpackedSize]
	mov	[hMemoryFileOut], eax
	invoke	GlobalLock, eax
	mov	ecx, [dwPackedSize]
	mov	edx, [dwFileIn]
	mov	[dwFileOut], eax
	sub	ecx, 04h
	add	edx, 04h
	invoke	unpack, edx, ecx, eax
	invoke	WriteFile, [hFileOut], [dwFileOut], [dwUnpackedSize], esp, 0
@@exit:	pop	ebx
	pop	esi
	pop	edi
@@safe:	pop	FS:[0]
	invoke	CloseHandle, [hFileOut]
	invoke	UnmapViewOfFile, [dwFileIn]
	invoke	CloseHandle, [hFileMapIn]
	invoke	CloseHandle, [hFileIn]
	invoke	GlobalUnlock, [hMemoryFileOut]
	invoke	GlobalFree, [hMemoryFileOut]
	jmp	ExitProcess
;##########################################################################
unpack proc lpInput:PTR BYTE, dwDataSize:DWORD, lpOutput:PTR BYTE
	push	edi
	push	esi
	push	ebx
	push	ebp
	mov	esi, [esp+18h]
	mov	ebp, [esp+18h]
	mov	edi, [esp+20h]
	mov	ecx, [esp+1Ch]
	mov	ecx, [esi+ecx-04h]
	add	esi, ecx
	mov	eax, [esi]
	mov	[edi], eax
	add	esi, 3
	add	edi, 3
	sub	dword ptr [esp+1Ch], 3+4
	sub	dword ptr [esp+1Ch], ecx
	xor	eax, eax
	xor	ebx, ebx
	xor	ecx, ecx
	xor	edx, edx
@@next:	lodsb
	bt	[ebp], edx
	jnc	@@nocp
	mov	ebx, eax
	lodsb
	mov	ecx, eax
	push	esi
	mov	esi, edi
	sub	esi, ebx
	sub	esi, ecx
	rep	movsb
	pop	esi
	dec	edi
	mov	al, [edi]
	dec	dword ptr [esp+1Ch]
@@nocp:	cmp	edx, 32
	jb	@@spok
	xor	edx, edx
	add	ebp, 4
@@spok:	stosb
	inc	edx
	dec	dword ptr [esp+1Ch]
	jnz	@@next
	pop	ebp
	pop	ebx
	pop	esi
	pop	edi
	ret
unpack endp
;##########################################################################
ProcessCmdLine proc
	push	edi
	push	esi
	push	ebx
	call	GetCommandLine
	mov	esi, eax
	mov	edi, OFFSET argv
	xor	ecx, ecx
	xor	ebx, ebx
	xor	edx, edx
@@cmss:	mov	eax, esi
	mov	dl, 20h
	cmp	byte ptr [esi], 22h
	sete	cl
	lea	edx, [edx+ecx*2]
	add	eax, ecx
	stosd
@@cm00:	inc	esi
	cmp	byte ptr [esi], 0
	je	@@done
	cmp	byte ptr [esi], dl
	jne	@@cm00
	mov	byte ptr [esi], 0
	add	esi, ecx
	inc	esi
	cmp	byte ptr [esi], 0
	je	@@done
	inc	[argc]
	jmp	@@cmss
@@done:	pop	ebx
	pop	esi
	pop	edi
	inc	[argc]
	ret
ProcessCmdLine endp
;##########################################################################
ErrorHandler proc C lpExcept:DWORD, lpFrame:DWORD, lpContext:DWORD, lpDispatch:DWORD
	mov	eax, [lpExcept]
	mov	ecx, [lpContext]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorThread, [eax][EXCEPTION_RECORD.ExceptionAddress], [ecx][CONTEXT.regEax], [ecx][CONTEXT.regEbx], [ecx][CONTEXT.regEcx], [ecx][CONTEXT.regEdx], [ecx][CONTEXT.regEsp], [ecx][CONTEXT.regEbp], [ecx][CONTEXT.regEsi], [ecx][CONTEXT.regEdi]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0

	mov	eax, [lpContext]
	m2m	[eax][CONTEXT.regEsp], [seh]
	m2m	[eax][CONTEXT.regEbp], [seh+4]
	m2m	[eax][CONTEXT.regEbx], [seh+8]
	m2m	[eax][CONTEXT.regEsi], [seh+12]
	m2m	[eax][CONTEXT.regEdi], [seh+16]
	m2m	[eax][CONTEXT.regEip], [seh+20]

	xor	eax, eax	; continue execution
	ret
ErrorHandler endp
;##########################################################################
ExceptionFilter proc lpExcept:DWORD
	mov	eax, [lpExcept]
	invoke	wsprintf, ADDR szMessage, ADDR szErrorFinal, [eax][EXCEPTION_RECORD.ExceptionAddress]
	invoke	WriteFile, [hStdOut], ADDR szMessage, eax, esp, 0
	invoke	ExitProcess, 0
	xor	eax, eax
	inc	eax		; EXCEPTION_EXECUTE_HANDLER
	ret
ExceptionFilter endp
;##########################################################################
;##########################################################################
;##########################################################################
end start